#!/usr/bin/env node
"use strict";
exports.__esModule = true;
var program = require("commander");
var index_1 = require("./index");
var log_1 = require("./lib/log");
var version = require('../package.json').version;
program
    .version(version)
    .option('-f, --force', 'overwrite tag if it exists already')
    .option('-n, --no-verify', 'skip git commit hooks')
    .option('-o, --override [version]', 'override recommended version number', '')
    .option('-p, --postfix [name]', 'a postfix such as "rc1", "canary" or "beta1"', '')
    .option('-t, --no-tag', 'skip tagging the commit')
    .parse(process.argv);
index_1.commitRelease({
    directory: process.cwd(),
    force: Boolean(program.force),
    postfix: program.postfix,
    skipHooks: Boolean(program.verify),
    tagRelease: Boolean(program.tag),
    version: program.override
})["catch"](function (err) {
    log_1.log.bug('uncaught error in commitRelease', err);
    process.exit(1);
});
