"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
exports.__esModule = true;
var execa = require("execa");
var fs_extra_1 = require("fs-extra");
var path_1 = require("path");
var log_1 = require("./lib/log");
exports.commitRelease = function (_a) {
    var directory = _a.directory, _b = _a.force, force = _b === void 0 ? false : _b, _c = _a.postfix, postfix = _c === void 0 ? '' : _c, _d = _a.skipHooks, skipHooks = _d === void 0 ? false : _d, _e = _a.tagRelease, tagRelease = _e === void 0 ? true : _e, _f = _a.version, version = _f === void 0 ? '' : _f;
    return __awaiter(_this, void 0, void 0, function () {
        var bumpVersion, tagExists, commitChanges, getNextVersion, stageChanges, tagCommit, generateChangelog, generateDependencyReport, formatMarkdown, binPath, BIN_CHANGELOG, BIN_CRV, BIN_MANIFEST_TO_README, BIN_PRETTIER, changelogPath, dependencyLogPath, manifestPath, manifest, nextVersion, _g, thisTagExists;
        var _this = this;
        return __generator(this, function (_h) {
            switch (_h.label) {
                case 0:
                    bumpVersion = function () { return __awaiter(_this, void 0, void 0, function () {
                        var args, stdout;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    args = ['version', nextVersion, '--no-git-tag-version', '--force'];
                                    return [4 /*yield*/, execa('npm', args, { cwd: directory })];
                                case 1:
                                    stdout = (_a.sent()).stdout;
                                    return [2 /*return*/, stdout];
                            }
                        });
                    }); };
                    tagExists = function () { return __awaiter(_this, void 0, void 0, function () {
                        var args, stdout;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    args = ['tag', '--list', nextVersion];
                                    return [4 /*yield*/, execa('git', args, { cwd: directory })];
                                case 1:
                                    stdout = (_a.sent()).stdout;
                                    return [2 /*return*/, stdout === nextVersion];
                            }
                        });
                    }); };
                    commitChanges = function () { return __awaiter(_this, void 0, void 0, function () {
                        var baseArgs, args, stdout;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    baseArgs = ['commit', '-m', "chore(release): " + nextVersion];
                                    args = skipHooks ? baseArgs.concat('--no-verify') : baseArgs;
                                    return [4 /*yield*/, execa('git', args, { cwd: directory })];
                                case 1:
                                    stdout = (_a.sent()).stdout;
                                    return [2 /*return*/, stdout];
                            }
                        });
                    }); };
                    getNextVersion = function () { return __awaiter(_this, void 0, void 0, function () {
                        var args, stdout;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    args = ['--directory', directory, '--postfix', postfix];
                                    return [4 /*yield*/, execa(BIN_CRV, args, { cwd: directory })];
                                case 1:
                                    stdout = (_a.sent()).stdout;
                                    return [2 /*return*/, stdout];
                            }
                        });
                    }); };
                    stageChanges = function () { return __awaiter(_this, void 0, void 0, function () {
                        var args, stdout;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    args = ['add', directory, '-A'];
                                    return [4 /*yield*/, execa('git', args, { cwd: directory })];
                                case 1:
                                    stdout = (_a.sent()).stdout;
                                    return [2 /*return*/, stdout];
                            }
                        });
                    }); };
                    tagCommit = function () { return __awaiter(_this, void 0, void 0, function () {
                        var baseArgs, args, stdout;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    baseArgs = ['tag', nextVersion];
                                    args = force ? baseArgs.concat('--force') : baseArgs;
                                    return [4 /*yield*/, execa('git', args, { cwd: directory })];
                                case 1:
                                    stdout = (_a.sent()).stdout;
                                    return [2 /*return*/, stdout];
                            }
                        });
                    }); };
                    generateChangelog = function () { return __awaiter(_this, void 0, void 0, function () {
                        var baseArgs, args, stdout;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    baseArgs = ['--preset', 'angular', '--release-count', '0', '--pkg', manifestPath];
                                    args = baseArgs.concat('--infile', changelogPath, '--outfile', changelogPath);
                                    return [4 /*yield*/, fs_extra_1.ensureFile(changelogPath)];
                                case 1:
                                    _a.sent();
                                    return [4 /*yield*/, execa(BIN_CHANGELOG, args, { cwd: directory })];
                                case 2:
                                    stdout = (_a.sent()).stdout;
                                    return [2 /*return*/, stdout];
                            }
                        });
                    }); };
                    generateDependencyReport = function () { return __awaiter(_this, void 0, void 0, function () {
                        var args, stdout;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    args = ['--no-footer', manifestPath];
                                    return [4 /*yield*/, execa(BIN_MANIFEST_TO_README, args, { cwd: directory })];
                                case 1:
                                    stdout = (_a.sent()).stdout;
                                    return [4 /*yield*/, fs_extra_1.ensureFile(dependencyLogPath)];
                                case 2:
                                    _a.sent();
                                    return [4 /*yield*/, fs_extra_1.writeFile(dependencyLogPath, stdout, { encoding: 'utf8' })];
                                case 3:
                                    _a.sent();
                                    return [2 /*return*/, stdout];
                            }
                        });
                    }); };
                    formatMarkdown = function () { return __awaiter(_this, void 0, void 0, function () {
                        var baseArgs, args, stdout;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    baseArgs = ['--parser', 'markdown', '--prose-wrap', 'always', '--print-width', '80'];
                                    args = baseArgs.concat('--write', changelogPath, dependencyLogPath);
                                    return [4 /*yield*/, execa(BIN_PRETTIER, args, { cwd: directory })];
                                case 1:
                                    stdout = (_a.sent()).stdout;
                                    return [2 /*return*/, stdout];
                            }
                        });
                    }); };
                    return [4 /*yield*/, execa('npm', ['bin'], { cwd: __dirname })];
                case 1:
                    binPath = (_h.sent()).stdout;
                    BIN_CHANGELOG = path_1.resolve(binPath, 'conventional-changelog');
                    BIN_CRV = path_1.resolve(binPath, 'conventional-recommended-version');
                    BIN_MANIFEST_TO_README = path_1.resolve(binPath, 'readme');
                    BIN_PRETTIER = path_1.resolve(binPath, 'prettier');
                    changelogPath = path_1.resolve(directory, 'CHANGELOG.md');
                    dependencyLogPath = path_1.resolve(directory, 'DEPENDENCIES.md');
                    manifestPath = path_1.resolve(directory, 'package.json');
                    manifest = fs_extra_1.readJSONSync(manifestPath, { throws: false }) || {};
                    _g = version;
                    if (_g) return [3 /*break*/, 3];
                    return [4 /*yield*/, getNextVersion()];
                case 2:
                    _g = (_h.sent());
                    _h.label = 3;
                case 3:
                    nextVersion = _g;
                    return [4 /*yield*/, tagExists()];
                case 4:
                    thisTagExists = _h.sent();
                    if (nextVersion === manifest.version) {
                        log_1.log.error("the current version is already " + nextVersion);
                        process.exit(1);
                    }
                    if (tagRelease && !force && thisTagExists) {
                        log_1.log.error("the tag " + nextVersion + " already exists");
                        process.exit(1);
                    }
                    return [4 /*yield*/, bumpVersion()];
                case 5:
                    _h.sent();
                    log_1.log.info("version: " + nextVersion);
                    return [4 /*yield*/, generateChangelog()];
                case 6:
                    _h.sent();
                    log_1.log.info("changelog: " + changelogPath);
                    return [4 /*yield*/, generateDependencyReport()];
                case 7:
                    _h.sent();
                    log_1.log.info("dependency report: " + dependencyLogPath);
                    return [4 /*yield*/, formatMarkdown()];
                case 8:
                    _h.sent();
                    return [4 /*yield*/, stageChanges()];
                case 9:
                    _h.sent();
                    return [4 /*yield*/, commitChanges()];
                case 10:
                    _h.sent();
                    log_1.log.info("release committed");
                    if (!tagRelease) return [3 /*break*/, 12];
                    return [4 /*yield*/, tagCommit()];
                case 11:
                    _h.sent();
                    log_1.log.info("release tagged");
                    _h.label = 12;
                case 12:
                    log_1.log.success('complete');
                    return [2 /*return*/];
            }
        });
    });
};
