"use strict";
exports.__esModule = true;
var chalk_1 = require("chalk");
var isVerbose = process.env.NODE_ENV === 'development';
var bug = function (value, err) {
    return console.error(chalk_1["default"].red('! %s\n\n! Please raise an issue at %s\n\n%s'), value, chalk_1["default"].underline('https://github.com/JamieMason/commit-release/issues'), String(err.stack).replace(/^/gm, '    '));
};
var error = function (value) { return console.error(chalk_1["default"].red('! %s'), value); };
var info = function (value) { return console.info(chalk_1["default"].blue('i %s'), value); };
var success = function (value) { return console.info(chalk_1["default"].green('✓ %s'), value); };
var verbose = isVerbose
    ? function (value) { return console.info(chalk_1["default"].grey('? %s'), value); }
    : function (value) { return undefined; };
exports.log = {
    bug: bug,
    error: error,
    info: info,
    success: success,
    verbose: verbose
};
